<template>
  <div class="color-map full-width">
    <div class="color-map__svg-wrapper">
      <svg
        class="color-map__svg-content"
        viewBox="0 0 1450 1050"
        preserveAspectRatio="xMidYMid meet"
        pointer-events="auto"
        clipPathUnits="objectBoundingBox"
      >
        <g class="regions">
          <path
            v-for="region in ecuadorRegions" :key="region"
            :id="region.id"
            :title="region.title"
            :d="region.d"
            class="land"
            pointer-events="all"
            ref="popupParentElement"
            :style="Object.keys(preparedData).includes(region.id) ? preparedData[region.id].style : 'fill: white; stroke-dasharray: 10'"
            @touchstart="onTouchStart(region)"
          >
            <title>{{ Object.keys(preparedData).includes(region.id) ? `${region.title}: ${preparedData[region.id].value}` : `No se dispone de datos sobre la provincia de ${region.title}` }}</title>
          </path>
        </g>
      </svg>

      <q-popup-proxy v-if="isPopupShowed">
        <q-banner>
          {{ popupInfoModel }}
        </q-banner>
      </q-popup-proxy>

    </div>

    <div class="color-map__legend content-start q-pa-sm">
      <q-chip
        v-for="item in Object.values(preparedData)"
        :key="item"
        size="0.8rem"
        :label="`${ item.title }: ${ item.value }`"
        dense
        square>
      </q-chip>
    </div>

  </div>
</template>

<script setup>
import { computed, ref, watchEffect, toRaw } from 'vue';
import { ecuadorRegions } from 'src/data/ecuador-regions';
import getNormalizedName from 'src/composables/get_normalized_name';
import getColorMapSettings from 'src/composables/get_color_map_settings';

const props = defineProps({
  indicator:  { type: String, required: true },
  data:       { type: Object, required: true },
});

const data = computed({
  get: () => props?.data,
});

let preparedData = {};
const settings = getColorMapSettings(props.indicator);

const isPopupShowed = ref(false);
const popupInfoModel = ref('');

const calculateColorOpacity = (minValue, maxValue, currentValue) => {
  if (currentValue === minValue) return 0.1;
  if (currentValue === maxValue) return 1.0;
  return 1 - 0.9 * (maxValue - currentValue) / (maxValue - minValue);
};

const prepareData = () => {
  const datasetValues = toRaw(data.value).map((item) => {
    switch (props.indicator) {
      case 'indicator_1_2':
      case 'indicator_3_4':
      case 'indicator_9':
        return +item['porcentaje'];
      case 'indicator_5_6':
      case 'indicator_7_8':
      case 'indicator_10_11':
      case 'indicator_12':
      case 'indicator_13':
      case 'indicator_14':
        return +item['register_number'];
      default:
        return parseFloat(item['variabilidad']);
    }
  });

  const positiveValues = datasetValues.filter((value) => value >= 0);
  const negativeValues = datasetValues.filter((value) => value < 0);

  const minPositiveDataValue = Math.min(...positiveValues);
  const maxPositiveDataValue = Math.max(...positiveValues);
  const minNegativeDataValue = Math.min(...negativeValues);
  const maxNegativeDataValue = Math.max(...negativeValues);

  const result = toRaw(data.value).reduce((acc, item) => {
    let currentValue;
    switch (props.indicator) {
      case 'indicator_1_2':
      case 'indicator_3_4':
      case 'indicator_9':
        currentValue = +item['porcentaje'];
        break;
      case 'indicator_5_6':
      case 'indicator_7_8':
      case 'indicator_10_11':
      case 'indicator_12':
      case 'indicator_13':
      case 'indicator_14':
        currentValue = +item['register_number'];
        break;
      default:
        currentValue = parseFloat(item['variabilidad']);
        break;
    }

    const isPositiveValue = currentValue >= 0;
    const [minValue, maxValue] = isPositiveValue
      ? [minPositiveDataValue, maxPositiveDataValue]
      : [Math.abs(maxNegativeDataValue), Math.abs(minNegativeDataValue)];

    const regionValue = props.indicator === 'indicator_15' ? `${settings.dataUnit}${currentValue}` : `${currentValue} ${settings.dataUnit}`;
    const regionOpacity = calculateColorOpacity(minValue, maxValue, isPositiveValue ? currentValue : Math.abs(currentValue));
    const style = `cursor: pointer; fill: ${isPositiveValue ? 'rgba(33, 113, 181,' : 'rgba(203, 24, 29,'}${regionOpacity})`;

    acc[item.region] = {
      title: getNormalizedName(item.region, 'region'),
      value: regionValue,
      opacity: regionOpacity,
      style: style
    };

    return acc;
  }, {});

  return result;
};

const onTouchStart = function(region) {
  isPopupShowed.value = true;
  popupInfoModel.value = Object.keys(preparedData).includes(region.id) ?
  `${region.title}: ${preparedData[region.id].value}` :
  `No se dispone de datos sobre la provincia de ${region.title}`
};

watchEffect(() => {
  preparedData = prepareData();
});

</script>

<style lang="scss">
@use './color-map-component-stylesheet.scss';

</style>